## ros-melodic-tf 1.12.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(tf)

include(CheckCXXCompilerFlag)
unset(COMPILER_SUPPORTS_CXX11 CACHE)
if(MSVC)
  # https://docs.microsoft.com/en-us/cpp/build/reference/std-specify-language-standard-version
  # MSVC has c++14 enabled by default, no need to specify c++11
else()
  check_cxx_compiler_flag(-std=c++11 COMPILER_SUPPORTS_CXX11)
  if(COMPILER_SUPPORTS_CXX11)
    add_compile_options(-std=c++11)
  endif()
endif()

find_package(catkin REQUIRED COMPONENTS
    angles
    geometry_msgs
    message_filters
    message_generation
    rosconsole
    roscpp
    rostime
    sensor_msgs
    std_msgs
    tf2_ros
)
find_package(Boost REQUIRED COMPONENTS thread system)

catkin_python_setup()

include_directories(
    include
    ${Boost_INCLUDE_DIR}
    ${catkin_INCLUDE_DIRS}
)

add_message_files(DIRECTORY msg FILES tfMessage.msg)
add_service_files(DIRECTORY srv FILES FrameGraph.srv)

generate_messages(DEPENDENCIES geometry_msgs sensor_msgs std_msgs)

catkin_package(
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
  CATKIN_DEPENDS geometry_msgs message_filters message_runtime roscpp sensor_msgs std_msgs tf2_ros rosconsole
)

add_library(${PROJECT_NAME}
    src/cache.cpp
    src/tf.cpp
    src/transform_broadcaster.cpp
    src/transform_listener.cpp
)
target_link_libraries(${PROJECT_NAME} ${catkin_LIBRARIES} ${Boost_LIBRARIES})
add_dependencies(${PROJECT_NAME} ${${PROJECT_NAME}_EXPORTED_TARGETS} ${catkin_EXPORTED_TARGETS})

# Debug
add_executable(tf_empty_listener src/empty_listener.cpp)
target_link_libraries(tf_empty_listener ${PROJECT_NAME})

add_executable(tf_echo src/tf_echo.cpp)
target_link_libraries(tf_echo ${PROJECT_NAME})

add_executable(tf_change_notifier src/change_notifier.cpp)
target_link_libraries(tf_change_notifier ${PROJECT_NAME})

add_executable(tf_monitor src/tf_monitor.cpp)
target_link_libraries(tf_monitor ${PROJECT_NAME})

add_executable(static_transform_publisher src/static_transform_publisher.cpp)
target_link_libraries(static_transform_publisher ${PROJECT_NAME})

# Tests
if(CATKIN_ENABLE_TESTING AND NOT ANDROID)

find_package(rostest REQUIRED)

catkin_add_gtest(tf_unittest test/tf_unittest.cpp)
target_include_directories(tf_unittest PRIVATE ${rostest_INCLUDE_DIRS})
target_link_libraries(tf_unittest ${PROJECT_NAME})

catkin_add_gtest(tf_quaternion_unittest test/quaternion.cpp)
target_link_libraries(tf_quaternion_unittest ${PROJECT_NAME})

catkin_add_gtest(test_transform_datatypes test/test_transform_datatypes.cpp)
target_link_libraries(test_transform_datatypes ${PROJECT_NAME} ${Boost_LIBRARIES})

add_executable(transform_listener_unittest test/transform_listener_unittest.cpp)
target_link_libraries(transform_listener_unittest ${PROJECT_NAME} ${GTEST_LIBRARIES})
add_rostest(test/transform_listener_unittest.launch)

# Disabled because of changes in TransformStorage
#catkin_add_gtest_future(tf_unittest_future test/tf_unittest_future.cpp)
#target_link_libraries(tf_unittest_future ${PROJECT_NAME})

catkin_add_gtest(test_velocity test/velocity_test.cpp)
target_link_libraries(test_velocity ${PROJECT_NAME})

#add_executable(test_transform_twist test/transform_twist_test.cpp)
#target_link_libraries(test_transform_twist ${PROJECT_NAME})
#catkin_add_gtest_build_flags(test_transform_twist)
#add_rostest(test/transform_twist_test.launch)

catkin_add_gtest(cache_unittest test/cache_unittest.cpp)
target_link_libraries(cache_unittest ${PROJECT_NAME})

add_executable(test_message_filter EXCLUDE_FROM_ALL test/test_message_filter.cpp)
target_link_libraries(test_message_filter tf ${Boost_LIBRARIES} ${GTEST_LIBRARIES})
add_rostest(test/test_message_filter.xml)


### Benchmarking
#catkin_add_gtest_future(tf_benchmark test/tf_benchmark.cpp)
#target_link_libraries(tf_benchmark ${PROJECT_NAME})

add_executable(testListener test/testListener.cpp)
target_link_libraries(testListener ${PROJECT_NAME} ${GTEST_LIBRARIES})
add_rostest(test/test_broadcaster.launch)

add_executable(testBroadcaster test/testBroadcaster.cpp)
target_link_libraries(testBroadcaster ${PROJECT_NAME})

catkin_add_nosetests(test/testPython.py) 
add_executable(tf_speed_test EXCLUDE_FROM_ALL test/speed_test.cpp)
target_link_libraries(tf_speed_test ${PROJECT_NAME})

if(TARGET tests)
    add_dependencies(tests testBroadcaster testListener transform_listener_unittest test_message_filter)
endif()

endif() # CATKIN_ENABLE_TESTING AND NOT ANDROID

install(DIRECTORY include/${PROJECT_NAME}/
    DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

# Install library
install(TARGETS ${PROJECT_NAME}
    ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
)

# Install executable
install(TARGETS tf_echo tf_empty_listener tf_change_notifier tf_monitor static_transform_publisher
    RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

# Install rosrun-able scripts
install(PROGRAMS
  scripts/bullet_migration_sed.py
  scripts/tf_remap
  scripts/view_frames
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION} )

=== debian/changelog ===
ros-melodic-tf (1.12.1-1stretch) stretch; urgency=high

  * Use process_time() for Python 3.8 compatibility (#205 <https://github.com/ros/geometry/issues/205>)
  * Bump CMake version to avoid CMP0048 warning (#204 <https://github.com/ros/geometry/issues/204>)
  * Add rostest include dirs (#195 <https://github.com/ros/geometry/issues/195>)
  * Remove trailing semicolons from tf sources (#187 <https://github.com/ros/geometry/issues/187>)
    * [tf] Removed trailing semicolons after functions from all sources
    Used the -Wpedantic compiler flag to find all occurrences
  * Allow to choose output precision in tf_echo (#186 <https://github.com/ros/geometry/issues/186>)
    * Allow to choose output precision in tf_echo
  * update how c++11 requirement is added (#184 <https://github.com/ros/geometry/issues/184>)
  * update install destination in CMakeLists.txt (#183 <https://github.com/ros/geometry/issues/183>)
    * export binary to right locations
    * specify archive and runtime destinations, update whitespace (#5 <https://github.com/ros/geometry/issues/5>)
  * add visibility macro
  * windows bring up, use ROS_DEPRECATED
  * Remove signals from find_package(Boost COMPONENTS ...)
  * fixing error of casting away constness in  method void tfSwapScalarEndian(const tfScalar& sourceVal, tfScalar& destVal) in line 626 of Vector3.h (#179 <https://github.com/ros/geometry/issues/179>)
  * Fix log output typo: message_notifier -> message_filter (#177 <https://github.com/ros/geometry/issues/177>)
    Almost all the log outputs use message_filter, except one. The warning
    text still referred to message_notifier. This commit fixes that.
  * Contributors: C-NR, James Xu, Maarten de Vries, Martin Günther, Shane Loretz, Victor Lamoine, Yoshua Nava

 -- Tully Foote <tfoote@osrfoundation.org>  Tue, 10 Mar 2020 07:00:00 -0000

ros-melodic-tf (1.12.0-1stretch) stretch; urgency=high

  * Adapt to new xmlrpcpp header location (#164 <https://github.com/ros/geometry/issues/164>)
  * Maintain & expose tf2 Buffer in shared_ptr for tf (#163 <https://github.com/ros/geometry/issues/163>)
    - Adds a tf2_ros::Buffer via a public accessor
    method to expose to customers of Transformer
    - Maintains the tf2_ros::Buffer in a shared_ptr
    to safely share access to the Buffer object
    - As this is targeting Melodic, adds c++11 compile
    flags to grant access to std::shared_ptr's
    - Reorders the include_directories in the CMakeLists
    to ensure the headers exposed in this package are
    read *before* the system installed catkin_INCLUDE_DIRS
    (otherwise changes to tf source headers are never detected
    during a catkin_make on a system with ros-*-geometry
    installed)
  * Prevent rates that result in core dump (0.0) or no limit on update rate at all (<0.0) #159 <https://github.com/ros/geometry/issues/159> (#160 <https://github.com/ros/geometry/issues/160>)
  * Fix empty yaml parsing (#153 <https://github.com/ros/geometry/issues/153>)
    Fixes #152 <https://github.com/ros/geometry/issues/152>
    The empty yaml was coming through as a list not a dict so was breaking the expectations.
    I used the shorthand or {} since I know any valid data won't evaluate to zero. A more complete solution is described here: https://stackoverflow.com/a/35777649/604099
  * Make python scripts Python3 compatible. (#151 <https://github.com/ros/geometry/issues/151>)
    * Python 3 fixes
    * Prefer str.format over operator % and small python3 fixes.
  * Contributors: Ian McMahon, Lucas Walter, Maarten de Vries, Tully Foote

 -- Tully Foote <tfoote@osrfoundation.org>  Wed, 02 May 2018 07:00:00 -0000

ros-melodic-tf (1.11.9-1stretch) stretch; urgency=high

  * Replace legacy python code with appropriate calls to tf2_ros (#149 <https://github.com/ros/geometry/issues/149>) (#134 <https://github.com/ros/geometry/issues/134>)
  * Replace deprecated Eigen module with Eigen3
  * Update minimum version for run dependency on tf2_ros
  * Add support for static_transforms in tf_monitor.
    Fixes #136 <https://github.com/ros/geometry/issues/136> with #134 <https://github.com/ros/geometry/issues/134> for tf_echo and view_frames.
  * Pass through allFramesAsDot time argument optionally.
  * remove vestigial includes. Fixes #146 <https://github.com/ros/geometry/issues/146> (#147 <https://github.com/ros/geometry/issues/147>)
  * Commented code caused error in documentation (#142 <https://github.com/ros/geometry/issues/142>)
  * [doc] Add migration notice in manifest. (#129 <https://github.com/ros/geometry/issues/129>)
  * Fix "stdlib.h: No such file or directory" errors in GCC-6
  * Fix error for null conversion.
  * Change version regex for graphviz in view_frames
  * fix for issue in getAngleShortestPath(), closes #102 <https://github.com/ros/geometry/issues/102>
  * Contributors: AndyZe, Edward Venator, Hodorgasm, Isaac I.Y. Saito, Michael Korn, Mike Purvis, Tom Moore, Tully Foote, Timo Röhling

 -- Tully Foote <tfoote@osrfoundation.org>  Fri, 14 Jul 2017 07:00:00 -0000

ros-melodic-tf (1.11.8-1stretch) stretch; urgency=high

  * Update assertQuaternionValid to check for NaNs
  * Remove outdated manifest loading in python files
  * update unit tests to catch https://github.com/ros/geometry_experimental/issues/102
  * Contributors: Chris Mansley, Michael Hwang, Tully Foote

 -- Tully Foote <tfoote@osrfoundation.org>  Fri, 04 Mar 2016 08:00:00 -0000

ros-melodic-tf (1.11.7-1stretch) stretch; urgency=high

  * add a unit test for pytf wait_for_transform
  * removed msg serv installation from cmakelists
  * generated autodoc
  * Fixed Vector3 documentation
  * display RPY in both radian and degree
  * Fixed command line arguments
  * using TimeStamp and FrameId in message filter
    this allows to use tf::MessageFilter with pcl::PointCloud<T>
    see #55 <https://github.com/ros/geometry/issues/55>
  * Added and optional third argument to specify publishing frequency


=== debian/control ===
Source: ros-melodic-tf
Section: misc
Priority: optional
Maintainer: Tully Foote <tfoote@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-angles, ros-melodic-catkin (>= 0.6.4), ros-melodic-geometry-msgs, ros-melodic-message-filters, ros-melodic-message-generation, ros-melodic-rosconsole, ros-melodic-roscpp, ros-melodic-rostest, ros-melodic-rostime, ros-melodic-rosunit, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-tf2-ros (>= 0.5.16)
Homepage: http://www.ros.org/wiki/tf
Standards-Version: 3.9.2

Package: ros-melodic-tf
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, graphviz, ros-melodic-geometry-msgs, ros-melodic-message-filters (>= 1.11.1), ros-melodic-message-runtime, ros-melodic-rosconsole, ros-melodic-roscpp, ros-melodic-roswtf, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-tf2-ros (>= 0.5.16)
Description: tf is a package that lets the user keep track of multiple coordinate frames over time.
 tf maintains the relationship between coordinate frames in a tree structure buffered in time, and lets the user transform points, vectors, etc between any two coordinate frames at any desired point in time. Migration: Since ROS Hydro, tf has been &quot;deprecated&quot; in favor of tf2. tf2 is an iteration on tf providing generally the same feature set more efficiently. As well as adding a few new features. As tf2 is a major change the tf API has been maintained in its current form. Since tf2 has a superset of the tf features with a subset of the dependencies the tf implementation has been removed and replaced with calls to tf2 under the hood. This will mean that all users will be compatible with tf2. It is recommended for new work to use tf2 directly as it has a cleaner interface. However tf will continue to be supported for through at least J Turtle.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-tf//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
